From 1f7ff628bdf999bec9b15f7964a076dcf3f56cfa Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 29 Jan 2020 20:41:07 +0300
Subject: [PATCH 06/59] AlpineApkBackend: WIP on using KAuth helper

---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  |  2 +-
 .../AlpineApkBackend/AlpineApkAuthHelper.h    |  2 +-
 .../AlpineApkBackend/AlpineApkBackend.cpp     | 34 +++++++++++++++++--
 .../AlpineApkBackend/AlpineApkBackend.h       |  3 ++
 .../backends/AlpineApkBackend/CMakeLists.txt  |  1 +
 .../org.kde.discover.alpineapkbackend.actions |  2 +-
 6 files changed, 39 insertions(+), 5 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index 6783f35cc..19236dcb3 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -32,7 +32,7 @@ using namespace KAuth;
 
 AlpineApkAuthHelper::AlpineApkAuthHelper() {}
 
-ActionReply AlpineApkAuthHelper::test_action(const QVariantMap &args)
+ActionReply AlpineApkAuthHelper::test(const QVariantMap &args)
 {
     const QString txt = args[QStringLiteral("txt")].toString();
 
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index 86f7d3dcf..947dcb7ac 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -31,5 +31,5 @@ public:
     AlpineApkAuthHelper();
 
 public Q_SLOTS:
-    ActionReply test_action(const QVariantMap &args);
+    ActionReply test(const QVariantMap &args);
 };
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
index 41b2e0532..ed016aef3 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
@@ -35,6 +35,8 @@
 #include <KPluginFactory>
 #include <KConfigGroup>
 #include <KSharedConfig>
+#include <KAuthExecuteJob>
+
 #include <QDebug>
 #include <QLoggingCategory>
 #include <QThread>
@@ -116,6 +118,19 @@ void AlpineApkBackend::populate()
     }
 }
 
+void AlpineApkBackend::handleKauthHelperReply(KJob *job)
+{
+    qCDebug(LOG_ALPINEAPK) << Q_FUNC_INFO;
+    KAuth::ExecuteJob* reply = static_cast<KAuth::ExecuteJob *>(job);
+    const QVariantMap replyData = reply->data();
+    if (reply->error() == 0) {
+        qCDebug(LOG_ALPINEAPK) << replyData[QLatin1String("reply")].toString();
+    } else {
+        const QString message = replyData.value(QLatin1String("errorString"), reply->errorString()).toString();
+        qCDebug(LOG_ALPINEAPK) << message;
+    }
+}
+
 void AlpineApkBackend::startCheckForUpdates()
 {
     if (m_fetching) {
@@ -123,11 +138,26 @@ void AlpineApkBackend::startCheckForUpdates()
     }
     qCDebug(LOG_ALPINEAPK) << "startCheckForUpdates()";
 
+    // temporary hack - finish updates check in 5 seconds
+    QTimer::singleShot(5000, this, &AlpineApkBackend::finishCheckForUpdates);
+
     m_fetching = true;
     emit fetchingChanged();
 
-    // temporary hack - finish updates check in 5 seconds
-    QTimer::singleShot(5000, this, &AlpineApkBackend::finishCheckForUpdates);
+    KAuth::Action testAction(QStringLiteral("org.kde.discover.alpineapkbackend.test"));
+    testAction.setHelperId(QStringLiteral("org.kde.discover.alpineapkbackend"));
+    testAction.setArguments({
+        { QStringLiteral("txt"), QLatin1String("Wooo!") },
+    });
+    if (!testAction.isValid()) {
+        qCWarning(LOG_ALPINEAPK) << "kauth action is not valid!";
+        return;
+    }
+
+    KAuth::ExecuteJob *reply = testAction.execute();
+    QObject::connect(reply, &KAuth::ExecuteJob::result,
+                     this, &AlpineApkBackend::handleKauthHelperReply);
+    reply->start();
 }
 
 void AlpineApkBackend::finishCheckForUpdates()
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
index 68a47bc92..a533cee39 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
@@ -29,6 +29,8 @@
 class AlpineApkReviewsBackend;
 class StandardBackendUpdater;
 class AlpineApkResource;
+class KJob;
+
 class AlpineApkBackend : public AbstractResourcesBackend
 {
     Q_OBJECT
@@ -55,6 +57,7 @@ public:
     bool hasApplications() const override;
 
 public Q_SLOTS:
+    void handleKauthHelperReply(KJob *job);
     void startCheckForUpdates();
     void finishCheckForUpdates();
 
diff --git a/libdiscover/backends/AlpineApkBackend/CMakeLists.txt b/libdiscover/backends/AlpineApkBackend/CMakeLists.txt
index f67cf84f9..ede3157f0 100644
--- a/libdiscover/backends/AlpineApkBackend/CMakeLists.txt
+++ b/libdiscover/backends/AlpineApkBackend/CMakeLists.txt
@@ -34,6 +34,7 @@ target_link_libraries(
         Qt5::Widgets
         KF5::CoreAddons
         KF5::ConfigCore
+        KF5::AuthCore
         Discover::Common
         apk-qt
 )
diff --git a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
index ba9ede912..3b9a3116e 100644
--- a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
+++ b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
@@ -1,4 +1,4 @@
-[org.kde.discover.alpineapkbackend.test_action]
+[org.kde.discover.alpineapkbackend.test]
 Name=Test Action
 Description=Just test
 Policy=auth_admin
-- 
GitLab


